-- CastBar management for WoW classic
if select(4, GetBuildInfo())>20000 then return end

local CastInfo = LibStub("LibKiwiClassicCast-1.0")
local GuidCastingInfo = CastInfo.GuidCastingInfo
local RegisterCallback = CastInfo.RegisterCallback
local UnregisterCallback = CastInfo.UnregisterCallback

local function RefreshCastBar(self, event, guid)
	if self.guid then
		local spellID, spellName, texture, start, duration, channeling = GuidCastingInfo(self.guid)
		if spellID then
			self.channeling = channeling
			self.maxValue = duration
			self.value    = GetTime() - start
			self:SetMinMaxValues(0, self.maxValue)
			self.Text:SetText(spellName)
			self.Icon:SetTexture(texture)
			self:SetAlpha(1)
			self:Show()
			return
		end
	end
	self:Hide()
end

function KiwiPlatesCastingBarFrame_OnUpdate(self, elapsed)
	local value = self.value + elapsed
	if value<self.maxValue then
		self.value = value
		self:SetValue(self.channeling and self.maxValue-value or value)
	else
		self:Hide()
	end
end

function KiwiPlatesCastingBarFrame_SetUnit(self, unit)
	local guid_pre = self.guid
	local guid_new = unit and UnitGUID(unit) or nil
	if guid_new~=guid_pre then
		self.guid = guid_new
		if guid_pre then
			UnregisterCallback( guid_pre, self )
		end
		if guid_new then
			RegisterCallback( guid_new, self, RefreshCastBar )
			RefreshCastBar(self)
		else
			self:Hide()
		end
	end
end